# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from ..core.unchecked_base_model import UncheckedBaseModel
from .evaluator_activation_deactivation_request_activate_item import EvaluatorActivationDeactivationRequestActivateItem
from .evaluator_activation_deactivation_request_deactivate_item import (
    EvaluatorActivationDeactivationRequestDeactivateItem,
)


class EvaluatorActivationDeactivationRequest(UncheckedBaseModel):
    activate: typing.Optional[typing.List[EvaluatorActivationDeactivationRequestActivateItem]] = pydantic_v1.Field(
        default=None
    )
    """
    Evaluators to activate on Monitoring. These will be automatically run on new Logs.
    """

    deactivate: typing.Optional[typing.List[EvaluatorActivationDeactivationRequestDeactivateItem]] = pydantic_v1.Field(
        default=None
    )
    """
    Evaluators to deactivate. These will not be run on new Logs.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
